

#include "Arduino.h"

#include "config.h"
#include "overheads.h"
#include "jobs.h"


static int spin_for(unsigned long how_long)
{
	unsigned long end;
	int counter = 0;
	end = micros() + max(how_long, MICROS_TIME) - MICROS_TIME;
	while(micros() <= end)
    		counter++;
	return counter;
}

static void f0(void)
{
}

#define DEFINE_SPIN_JOB(_duration) 	\
	static void f ## _duration (void) \
	{				\
		spin_for(_duration);	\
	}

DEFINE_SPIN_JOB(10)
DEFINE_SPIN_JOB(25)
DEFINE_SPIN_JOB(50)
DEFINE_SPIN_JOB(75)
DEFINE_SPIN_JOB(100)
DEFINE_SPIN_JOB(250)
DEFINE_SPIN_JOB(500)
DEFINE_SPIN_JOB(750)
DEFINE_SPIN_JOB(1000)
DEFINE_SPIN_JOB(1250)
DEFINE_SPIN_JOB(1500)
DEFINE_SPIN_JOB(1750)
DEFINE_SPIN_JOB(2000)
DEFINE_SPIN_JOB(2250)
DEFINE_SPIN_JOB(2500)
DEFINE_SPIN_JOB(2750)
DEFINE_SPIN_JOB(3000)
DEFINE_SPIN_JOB(3500)
DEFINE_SPIN_JOB(4000)
DEFINE_SPIN_JOB(4500)
DEFINE_SPIN_JOB(5000)


job_t get_spin_job_for_wcet(unsigned long wcet)
{
	/* default: just return from the job */
	job_t job = f0;
#define CHECK_IF_WCET_FITS(_duration) \
	if (wcet >= _duration) \
		job = f ## _duration;

	/* now check if progressively larger spin loops fit into the job */
	CHECK_IF_WCET_FITS(10)
	CHECK_IF_WCET_FITS(25)
	CHECK_IF_WCET_FITS(50)
	CHECK_IF_WCET_FITS(75)
	CHECK_IF_WCET_FITS(100)
	CHECK_IF_WCET_FITS(250)
	CHECK_IF_WCET_FITS(500)
	CHECK_IF_WCET_FITS(750)
	CHECK_IF_WCET_FITS(1000)
	CHECK_IF_WCET_FITS(1250)
	CHECK_IF_WCET_FITS(1500)
	CHECK_IF_WCET_FITS(1750)
	CHECK_IF_WCET_FITS(2000)
	CHECK_IF_WCET_FITS(2250)
	CHECK_IF_WCET_FITS(2500)
	CHECK_IF_WCET_FITS(2750)
	CHECK_IF_WCET_FITS(3000)
	CHECK_IF_WCET_FITS(3500)
	CHECK_IF_WCET_FITS(4000)
	CHECK_IF_WCET_FITS(4500)
	CHECK_IF_WCET_FITS(5000)

	return job;
}

/* if the tasks table is statically compiled into the image, include it here */
#ifdef TABLES_IN_FLASH
#include "tasks.h"
#include "gentab_ts.h"
#endif
