#include "Arduino.h"

#include "panic.h"

#define SHORT 100
#define LONG  500
#define GAP   200

static void flash(unsigned long how_long)
{
	digitalWrite(LED_BUILTIN, HIGH);
	delay(how_long);
	digitalWrite(LED_BUILTIN, LOW);
	delay(GAP);
}

static void sos(void)
{
	/* Morse code: SOS */
	flash(SHORT);
	flash(SHORT);
	flash(SHORT);
	flash(LONG);
	flash(LONG);
	flash(LONG);
	flash(SHORT);
	flash(SHORT);
	flash(SHORT);
	delay(1000);
}

void __attribute__((noreturn)) panic(const __FlashStringHelper *msg)
{
	while (1) {
		Serial.print(F("panic: "));
		Serial.println(msg);
		sos();
	}
}

void __attribute__((noreturn)) panic(const char *msg)
{
	while (1) {
		Serial.print(F("panic: "));
		Serial.println(msg);
		sos();
	}
}
