#ifndef PANIC_H
#define PANIC_H

void __attribute__((noreturn)) panic(const char *msg);
void __attribute__((noreturn)) panic(const __FlashStringHelper *msg);

#define BUG_ON(cond) \
	do { if ((cond)) panic(F(#cond)); } while (0)

// empty default template
template <bool b>
struct StaticAssert {};

// template specialized on true
template <>
struct StaticAssert<true>
{
    static void assert() {}
};

#define BUILD_BUG_ON(condition) (StaticAssert<!(condition)>::assert())

#endif
