#ifndef SCHED_H
#define SCHED_H

#include "jobs.h"

void oe_init(void);
sched_decision_t oe_schedule(void);

struct idle_time_record {
	unsigned long start;
	unsigned int duration;

	unsigned long end() const {
		return start + duration;
	}
};

struct irregularity_record {
	unsigned int job_id;
	unsigned long delay;
};

#ifndef TABLES_IN_FLASH

void oe_set_hyperperiod(unsigned long hp);
void oe_set_idle_times(struct idle_time_record *recs, unsigned int count);
void oe_set_irregularities_for(byte task_id,
	struct irregularity_record *recs, unsigned int count);

#endif

#endif
