#ifndef SCHEDULE_SWITCH_H
#define SCHEDULE_SWITCH_H

#if defined(WANT_SCHED_FP)

#include "sched_fp.h"
#define SCHEDULER_NAME "NP-FP"
#define SCHEDULER_KEY "FP"
#define schedule fp_schedule
#define schedule_init fp_init

#elif defined(WANT_SCHED_EDF)

#include "sched_edf.h"
#define SCHEDULER_NAME "NP-EDF"
#define SCHEDULER_KEY "DL"
#define schedule edf_schedule
#define schedule_init edf_init

#elif defined(WANT_SCHED_PCRM)

#include "sched_pcrm.h"
#define SCHEDULER_NAME "Precautious-RM"
#define SCHEDULER_KEY "PC"
#define schedule pcrm_schedule
#define schedule_init pcrm_init

#elif defined(WANT_SCHED_EDF_CW)

#include "sched_edf_cw.h"
#define SCHEDULER_NAME "EDF-CW"
#define SCHEDULER_KEY "CW"
#define schedule edf_cw_schedule
#define schedule_init edf_cw_init

#elif defined(WANT_SCHED_OE)

#include "sched_oe.h"
#define SCHEDULER_NAME "Offline Equivalence"
#define SCHEDULER_KEY "OE"
#define schedule oe_schedule
#define schedule_init oe_init

#elif defined(WANT_SCHED_TABLE)

#include "sched_table.h"
#define SCHEDULER_NAME "Table-Driven Scheduler"
#define SCHEDULER_KEY "TD"
#define schedule tt_schedule
#define schedule_init tt_init

#else
#error No scheduler selected?
#endif

#endif

