#ifndef STOPWATCH_H
#define STOPWATCH_H

#include <limits.h>

#include "Arduino.h"

struct StopWatch
{
	unsigned long _start;
	unsigned long count;
	unsigned long min_val;
	unsigned long max_val;
	unsigned long total;

	StopWatch()
	{
		reset();
	}

	void reset()
	{
		_start = count = max_val = total = 0;
		min_val = ULONG_MAX;
	}

	void start()
	{
		_start = micros();
	}

	void stop()
	{
		unsigned long sample = micros() - _start;
		total += sample;
		count++;
		if (sample < min_val)
			min_val = sample;
		if (sample > max_val)
			max_val = sample;
	}
};

#endif
