
#include "Arduino.h"
#include "panic.h"
#include "tasks.h"

/* if the tasks table is statically compiled into the image, it's defined in
 * functions.cpp */
#ifndef TABLES_IN_FLASH

Task tasks[MAX_TASKS];

byte number_of_tasks = 0;

byte add_task(job_t code,
	unsigned long wcet, unsigned long deadline, unsigned long period)
{
	if (number_of_tasks == MAX_TASKS)
		panic("too many tasks");

	tasks[number_of_tasks].wcet = wcet;
	tasks[number_of_tasks].period = period;
	tasks[number_of_tasks].deadline = deadline;
	tasks[number_of_tasks].job_function = code;

	number_of_tasks++;

	/* return task index */
	return number_of_tasks - 1;
}

#endif
