#ifndef TASKS_H
#define TASKS_H

#include "jobs.h"
#include "config.h"

struct Task
{
	unsigned long wcet;       // in microseconds
	unsigned long period;      // in microseconds
	unsigned long deadline;    // in microseconds
	job_t job_function; // pointer to code for job
};

const int MAX_TASKS = 16; // the maximum number of tasks

extern Task tasks[MAX_TASKS];

extern byte  number_of_tasks;

#ifndef TABLES_IN_FLASH
/* dynamic reconfiguration only if tables are not compiled in */

static inline void clear_tasks(void)
{
	number_of_tasks = 0;
}

byte add_task(job_t code,
	unsigned long wcet, unsigned long deadline, unsigned long period);

#endif

#endif
