#!/bin/bash

TIME_PER_EXP=31.5

SCHEDULERS="TABLE OE"
TASK_COUNTS="3 6 9 12"
NUM_EXPERIMENTS=1000

SCRIPTS_DIR=`dirname $0`
if [ ! -z "SCRIPTS_DIR" ]
then
    SCRIPTS_DIR="${SCRIPTS_DIR}/"
fi

MK_INC="${SCRIPTS_DIR}mk-includes.sh"

DATA_DIR="${SCRIPTS_DIR}../Data/SD/datan"

for S in $SCHEDULERS
do
	for N in $TASK_COUNTS
	do
		for E in `seq 1 $NUM_EXPERIMENTS`
		do
			DIR="${DATA_DIR}${N}/${E}/"
			echo "=======[" `date` "]======="
            ../scripts/mk-includes.sh "$DIR" "$S" || exit 1
			echo -n "Compiling..."
			(make clean; make) > compile.log 2>&1
			if [ $? == 0 ]
			then
				echo  "done."
			else
				echo "FAILED!"
				mv compile.log fail-datan$N-$E-$S.log
				continue
			fi
			echo -n "Waiting..."
			wait
			echo  "done."
			echo -n "Uploading..."
			make upload || exit 1
			echo  "done."
			sleep ${TIME_PER_EXP} &
		done
	done
done

echo -n "Waiting..."
wait
echo  "done."
