#!/usr/bin/env python3

import sys
import os
import math

MAX_TASKS = 16

SPIN_SIZES = [
     0,
    10,
    25,
    50,
    75,
    100,
    250,
    500,
    750,
    1000,
    1250,
    1500,
    1750,
    2000,
    2250,
    2500,
    2750,
    3000,
    3500,
    4000,
    4500,
    5000,
]

def select_f(wcet):
    return max((x for x in SPIN_SIZES if x < wcet))

f = open("gentab_ts.h", "w")

print("""
/* NOTE: This file is automatically generated and should be included
 * only from functions.cpp. */

Task tasks[MAX_TASKS] = {""", file=f)

tasks = 0
for line in open(sys.argv[1] + '/ts.txt').readlines()[2:]:
    params = [int(x) for x in line.strip().split(" ")]
    print("\t{{ {0:>7d}UL, {1:>7d}UL, {2:>7d}UL, f{3:d} }},".format(
        params[0], params[1], params[2], select_f(params[0])), file=f)
    tasks += 1

for _ in range(tasks, MAX_TASKS):
    print("\t{{ {0:>7d}UL, {1:>7d}UL, {2:>7d}UL,  NULL }},".format(
        0, 0, 0), file=f)

print("};", file=f)

print("""
byte number_of_tasks = {0};
""".format(tasks), file=f)

f.close()
